Public Class Form1

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        For i As Integer = 1880 To 2020
            If IsLeapYear0(i) Then lstLeapYears0.Items.Add(i)
            If IsLeapYear1(i) Then lstLeapYears1.Items.Add(i)
            If IsLeapYear2(i) Then lstLeapYears2.Items.Add(i)
            If IsLeapYear3(i) Then lstLeapYears3.Items.Add(i)
            If DateTime.IsLeapYear(i) Then lstDateTime.Items.Add(i)
        Next i
    End Sub

    Public Function IsLeapYear0(ByVal y As Integer) As Boolean
        On Error Resume Next
        IsLeapYear0 = False
        'If the year is evenly divisible by 4 and not by 100, then this
        'is a leap year.
        If y Mod 4 = 0 And y Mod 100 <> 0 Then
            IsLeapYear0 = True
            'If the year is evenly divisible by 4 and 100, then check to
            'see if the quotient of year divided by 100 is also evenly
            'divisible by 4. If it is, then this is a leap year.
        ElseIf y Mod 4 = 0 And y Mod 100 = 0 Then
            If (y \ 100) Mod 4 = 0 Then IsLeapYear0 = True
        End If
    End Function

    Private Function IsLeapYear1(ByVal y As Integer) As Boolean
        If y Mod 4 <> 0 Then Return False
        If y Mod 400 = 0 Then Return True
        If y Mod 100 = 0 Then Return False
        Return True
    End Function

    Private Function IsLeapYear2(ByVal y As Integer) As Boolean
        Return (y Mod 4 = 0) AndAlso _
            ((y Mod 100 <> 0) OrElse (y Mod 400 = 0))
    End Function

    Private Function IsLeapYear3(ByVal y As Integer) As Boolean
        Return IsDate("2/29/" & y)
    End Function
End Class
